Compare commits

..

23 Commits

Author SHA1 Message Date
mag37
160f4a2c5f Test to remove the <none>-tagged copy after backup is created 2025-11-29 17:06:06 +01:00
mag37
85e2b2c02c added timestamp variables to exports, formatting 2025-11-28 16:32:56 +01:00
mag37
644cbaedd1 moved the prune logic and made a forced prune with -k flag 2025-11-24 22:18:07 +01:00
mag37
eeb719296d cleaned up the config info queries 2025-11-24 22:07:25 +01:00
mag37
9c44a5176d fixed missing formatting variables 2025-11-22 20:22:57 +01:00
mag37
e191971933 label-fix to fallback to default :latest when unset 2025-11-21 14:03:32 +01:00
mag37
c3c7206622 quickfixes to not be completely broken - but needs much more work 2025-11-20 20:22:04 +01:00
mag37
c1124676d1 reworked the image listing when removing backups to properly list all dockcheck/*** backups 2025-11-15 20:53:45 +01:00
mag37
6576a36fda moved the cleanup and prune logic to always run. Changed some wording on messages. 2025-11-15 20:02:48 +01:00
mag37
42d35b7a03 enclosing some variables in braces due to strings messing up 2025-11-13 20:27:31 +01:00
mag37
fc58962f79 added forgotten variables, corrected some variables 2025-11-13 20:18:25 +01:00
mag37
ff2006437f final logic to get image backups to work for testing 2025-11-13 17:49:52 +01:00
mag37
ac98e81172 datecheck function rewrite 2025-11-13 17:29:53 +01:00
mag37
6fefcbc3dd added new variables, options and setup 2025-11-13 16:30:46 +01:00
Oleh Astappiev
c33c9f4387 Fix version check condition (#239) 2025-11-13 06:17:25 +01:00
mag37
c34d52bde0 the missing ) 2025-11-01 09:25:11 +01:00
mag37
7ea97d06ce New option -R and bugfix + cleanup (#236)
* Cleaned up legacy structure
* Add -R flag to skip container recreation after pulling images (#235)
* Added new -R option: Skip Container recreation
---------

Co-authored-by: mag37 <robin.ivehult@gmail.com>
Co-authored-by: NapalmZ <willy.baessato@gmail.com>
2025-11-01 09:14:49 +01:00
mag37
8970ee3f20 added to the sponsorlist 2025-10-21 20:47:10 +02:00
mag37
12a51d8e83 added new sponsors 2025-10-08 19:00:29 +02:00
mag37
24cae63b61 bugfix - unquoted var in list
Versionbump.
2025-10-07 08:25:44 +02:00
mag37
05e5b23e7b bugfix - unquoted var in list
Versionbump.
2025-10-07 08:24:31 +02:00
mag37
be58805824 hot-patch unquoted variable in updates list 2025-10-06 10:18:38 +02:00
mag37
af0d0d3f6e label and update list rework (#229)
* Reformatting the updates available list

* rewritten list padding to be dynamic

* Label rework + clearer messages (#228)

- Moved up label check and logic to earlier in the process, to iterate the whole run the same way if `-l` option is passed.
- Added messaging to make it clearer.
- Clarified Readme and --help message.
- Clarified prune message (to mean ALL dangling, not just currently updated).
2025-10-03 09:22:17 +02:00
4 changed files with 181 additions and 127 deletions

View File

@@ -22,6 +22,22 @@
___ ___
## Changelog ## Changelog
- **v0.7.4**:
- Added new option `-R`:
- Will skip container recreation after pulling images.
- Allows for more control and possible pipeline integration.
- Fixes:
- Bugfix for *value too great* error due to leading zeroes - solved with base10 conversion.
- Clean up of some legacy readme sections.
- **v0.7.3**: Bugfix - unquoted variable in printf list caused occasional issues.
- **v0.7.2**:
- Label rework:
- Moved up label logic to work globally on the current run.
- Only iterating on labeled containers when used with `-l` option, not listing others.
- Clarified messaging and readme/help texts.
- List reformatting for "available updates" numbering to easier highlight and copy:
- Padded with zero, changed `)` to `-`, example: `02 - homer`
- Can be selected by writing `2,3,4` or `02,03,04`.
- **v0.7.1**: - **v0.7.1**:
- Added support for multiple notifications using the same template - Added support for multiple notifications using the same template
- Added support for notification output format - Added support for notification output format
@@ -32,22 +48,6 @@ ___
- `<channel>_CONTAINERSONLY` : Only notify for docker container related updates - `<channel>_CONTAINERSONLY` : Only notify for docker container related updates
- `<channel>_ALLOWEMPTY` : Always send notifications, even when empty - `<channel>_ALLOWEMPTY` : Always send notifications, even when empty
- `<channel>_OUTPUT` : Define output format - `<channel>_OUTPUT` : Define output format
- **v0.7.0**:
- Bugfix: snooze dockcheck.sh-self-notification and some config clarification.
- Added authentication support to Ntfy.sh.
- Added suport for sendmail in the SMTP-template.
- **v0.6.9**:
- Bugfix: label logic didn't skip recreation (skipped pulling).
- Added comma separated search filtering so you can selectively search exactly which containers to check/update.
- eg: `dockcheck.sh -yp homer,dozzle`
- **v0.6.8**:
- Bugfix: Unbound variable in notify_v2.sh
- New option: "DisplaySourcedFiles" *config* added to list what files get sourced
- **v0.6.7**: Snooze feature, curl, and consolidation
- Added snooze feature to delay notifications
- Added configurable default curl arguments
- Consolidated and standardized notify template update notifications
- Added curl error handling
___ ___
@@ -69,12 +69,13 @@ Options:
-h Print this Help. -h Print this Help.
-i Inform - send a preconfigured notification. -i Inform - send a preconfigured notification.
-I Prints custom releasenote urls alongside each container with updates in CLI output (requires urls.list). -I Prints custom releasenote urls alongside each container with updates in CLI output (requires urls.list).
-l Only update if label is set. See readme. -l Only include containers with label set. See readme.
-m Monochrome mode, no printf colour codes and hides progress bar. -m Monochrome mode, no printf colour codes and hides progress bar.
-M Prints custom releasenote urls as markdown (requires template support). -M Prints custom releasenote urls as markdown (requires template support).
-n No updates, only checking availability. -n No updates, only checking availability.
-p Auto-Prune dangling images after update. -p Auto-Prune dangling images after update.
-r Allow checking for updates/updating images for docker run containers. Won't update the container. -r Allow checking for updates/updating images for docker run containers. Won't update the container.
-R Skip container recreation after pulling images.
-s Include stopped containers in the check. (Logic: docker ps -a). -s Include stopped containers in the check. (Logic: docker ps -a).
-t N Set a timeout (in seconds) per container for registry checkups, 10 is default. -t N Set a timeout (in seconds) per container for registry checkups, 10 is default.
-u Allow automatic self updates - caution as this will pull new code and autorun it. -u Allow automatic self updates - caution as this will pull new code and autorun it.
@@ -104,7 +105,7 @@ After the updates are complete, you'll get prompted if you'd like to prune dangl
___ ___
## Dependencies ## Dependencies
- Running docker (duh) and compose, either standalone or plugin. (see [Podman fork](https://github.com/sudo-kraken/podcheck) - Running docker (duh) and compose, either standalone or plugin. (see [Podman fork](https://github.com/sudo-kraken/podcheck))
- Bash shell or compatible shell of at least v4.3 - Bash shell or compatible shell of at least v4.3
- POSIX `xargs`, usually default but can be installed with the `findutils` package - to enable async. - POSIX `xargs`, usually default but can be installed with the `findutils` package - to enable async.
- [jq](https://github.com/jqlang/jq) - [jq](https://github.com/jqlang/jq)
@@ -283,10 +284,12 @@ Optionally add labels to compose-files. Currently these are the usable labels:
mag37.dockcheck.only-specific-container: true mag37.dockcheck.only-specific-container: true
mag37.dockcheck.restart-stack: true mag37.dockcheck.restart-stack: true
``` ```
- `mag37.dockcheck.update: true` will when used with the `-l` option only update containers with this label and skip the rest. Will still list updates as usual. - `mag37.dockcheck.update: true` will when used with the `-l` option only check and update containers with this label set and skip the rest.
- `mag37.dockcheck.only-specific-container: true` works instead of the `-F` option, specifying the updated container when doing compose up, like `docker compose up -d homer`. - `mag37.dockcheck.only-specific-container: true` works instead of the `-F` option, specifying the updated container when doing compose up, like `docker compose up -d homer`.
- `mag37.dockcheck.restart-stack: true` works instead of the `-f` option, forcing stop+restart on the whole compose-stack (Caution: Will restart on every updated container within stack). - `mag37.dockcheck.restart-stack: true` works instead of the `-f` option, forcing stop+restart on the whole compose-stack (Caution: Will restart on every updated container within stack).
Adding or modifying labels in compose-files requires a restart of the container to take effect.
## Workaround for non **amd64** / **arm64** ## Workaround for non **amd64** / **arm64**
`regctl` provides binaries for amd64/arm64, to use on other architecture you could try this workaround. `regctl` provides binaries for amd64/arm64, to use on other architecture you could try this workaround.
Run regctl in a container wrapped in a shell script. Copied from [regclient/docs/install.md](https://github.com/regclient/regclient/blob/main/docs/install.md): Run regctl in a container wrapped in a shell script. Copied from [regclient/docs/install.md](https://github.com/regclient/regclient/blob/main/docs/install.md):
@@ -345,11 +348,17 @@ dockcheck is created and released under the [GNU GPL v3.0](https://www.gnu.org/l
## Sponsorlist ## Sponsorlist
- [avegy](https://github.com/avegy) :small_orange_diamond: [avegy](https://github.com/avegy)
- [eichhorn](https://github.com/eichhorn) :small_orange_diamond: [eichhorn](https://github.com/eichhorn)
- [stepdg](https://github.com/stepdg) :small_orange_diamond: [stepdg](https://github.com/stepdg)
- [acer2220](https://github.com/acer2220) :small_orange_diamond: [acer2220](https://github.com/acer2220)
- [shgew](https://github.com/shgew) :small_orange_diamond: [shgew](https://github.com/shgew)
:small_orange_diamond: [jonas3456](https://github.com/jonas3456)
:small_orange_diamond: [4ndreasH](https://github.com/4ndreasH)
:small_orange_diamond: [markoe01](https://github.com/markoe01)
:small_orange_diamond: [mushrowan](https://github.com/mushrowan)
:small_orange_diamond:
___ ___
### The [story](https://mag37.org/posts/project_dockcheck/) behind it. 1 year in retrospect. ### The [story](https://mag37.org/posts/project_dockcheck/) behind it. 1 year in retrospect.

View File

@@ -19,6 +19,7 @@
#OnlyLabel=true # Only update if label is set. See readme. #OnlyLabel=true # Only update if label is set. See readme.
#ForceRestartStacks=true # Force stop+start stack after update. Caution: restarts once for every updated container within stack. #ForceRestartStacks=true # Force stop+start stack after update. Caution: restarts once for every updated container within stack.
#DRunUp=true # Allow updating images for docker run, wont update the container. #DRunUp=true # Allow updating images for docker run, wont update the container.
#SkipRecreate # Skip container recreation after pulling images.
#MonoMode=true # Monochrome mode, no printf colour codes and hides progress bar. #MonoMode=true # Monochrome mode, no printf colour codes and hides progress bar.
#PrintReleaseURL=true # Prints custom releasenote urls alongside each container with updates (requires urls.list)` #PrintReleaseURL=true # Prints custom releasenote urls alongside each container with updates (requires urls.list)`
#PrintMarkdownURL=true # Prints custom releasenote urls as markdown #PrintMarkdownURL=true # Prints custom releasenote urls as markdown
@@ -89,4 +90,3 @@
# TELEGRAM_TOPIC_ID="0" # TELEGRAM_TOPIC_ID="0"
# #
# FILE_PATH="${ScriptWorkDir}/updates_available.txt" # FILE_PATH="${ScriptWorkDir}/updates_available.txt"

View File

@@ -1,6 +1,6 @@
#!/usr/bin/env bash #!/usr/bin/env bash
VERSION="v0.7.1" VERSION="v0.7.4"
# ChangeNotes: Add support for multiple notifications of the same type, output formatting, and file output # ChangeNotes: New option -R to pull without recreation. Fixes: value too great error, legacy cleanups.
Github="https://github.com/mag37/dockcheck" Github="https://github.com/mag37/dockcheck"
RawUrl="https://raw.githubusercontent.com/mag37/dockcheck/main/dockcheck.sh" RawUrl="https://raw.githubusercontent.com/mag37/dockcheck/main/dockcheck.sh"
@@ -42,11 +42,13 @@ Help() {
echo "-h Print this Help." echo "-h Print this Help."
echo "-i Inform - send a preconfigured notification." echo "-i Inform - send a preconfigured notification."
echo "-I Prints custom releasenote urls alongside each container with updates in CLI output (requires urls.list)." echo "-I Prints custom releasenote urls alongside each container with updates in CLI output (requires urls.list)."
echo "-l Only update if label is set. See readme." echo "-k N Number of days to store image backups before pruning - this also enables the backup function."
echo "-l Only include containers with label set. See readme."
echo "-m Monochrome mode, no printf colour codes and hides progress bar." echo "-m Monochrome mode, no printf colour codes and hides progress bar."
echo "-M Prints custom releasenote urls as markdown (requires template support)." echo "-M Prints custom releasenote urls as markdown (requires template support)."
echo "-n No updates; only checking availability without interaction." echo "-n No updates; only checking availability without interaction."
echo "-p Auto-prune dangling images after update." echo "-p Auto-prune dangling images after update."
echo "-R Skip container recreation after pulling images."
echo "-r Allow checking for updates/updating images for docker run containers. Won't update the container." echo "-r Allow checking for updates/updating images for docker run containers. Won't update the container."
echo "-s Include stopped containers in the check. (Logic: docker ps -a)." echo "-s Include stopped containers in the check. (Logic: docker ps -a)."
echo "-t Set a timeout (in seconds) per container for registry checkups, 10 is default." echo "-t Set a timeout (in seconds) per container for registry checkups, 10 is default."
@@ -76,8 +78,10 @@ Stopped=${Stopped:-""}
CollectorTextFileDirectory=${CollectorTextFileDirectory:-} CollectorTextFileDirectory=${CollectorTextFileDirectory:-}
Exclude=${Exclude:-} Exclude=${Exclude:-}
DaysOld=${DaysOld:-} DaysOld=${DaysOld:-}
DaysKept=${DaysKept:-}
OnlySpecific=${OnlySpecific:-false} OnlySpecific=${OnlySpecific:-false}
SpecificContainer=${SpecificContainer:-""} SpecificContainer=${SpecificContainer:-""}
SkipRecreate=${SkipRecreate:-false}
Excludes=() Excludes=()
GotUpdates=() GotUpdates=()
NoUpdates=() NoUpdates=()
@@ -95,7 +99,11 @@ c_blue="\033[0;34m"
c_teal="\033[0;36m" c_teal="\033[0;36m"
c_reset="\033[0m" c_reset="\033[0m"
while getopts "ayfFhiIlmMnprsuvc:e:d:t:x:" options; do # Timestamps
RunTimestamp=$(date +'%Y-%m-%d_%H%M')
RunEpoch=$(date +'%s')
while getopts "ayfFhiIlmMnprsuvc:e:d:k:t:x:R" options; do
case "${options}" in case "${options}" in
a|y) AutoMode=true ;; a|y) AutoMode=true ;;
c) CollectorTextFileDirectory="${OPTARG}" ;; c) CollectorTextFileDirectory="${OPTARG}" ;;
@@ -105,11 +113,13 @@ while getopts "ayfFhiIlmMnprsuvc:e:d:t:x:" options; do
F) OnlySpecific=true ;; F) OnlySpecific=true ;;
i) Notify=true ;; i) Notify=true ;;
I) PrintReleaseURL=true ;; I) PrintReleaseURL=true ;;
k) DaysKept="${OPTARG}" ;;
l) OnlyLabel=true ;; l) OnlyLabel=true ;;
m) MonoMode=true ;; m) MonoMode=true ;;
M) PrintMarkdownURL=true ;; M) PrintMarkdownURL=true ;;
n) DontUpdate=true; AutoMode=true;; n) DontUpdate=true; AutoMode=true;;
p) AutoPrune=true ;; p) AutoPrune=true ;;
R) SkipRecreate=true ;;
r) DRunUp=true ;; r) DRunUp=true ;;
s) Stopped="-a" ;; s) Stopped="-a" ;;
t) Timeout="${OPTARG}" ;; t) Timeout="${OPTARG}" ;;
@@ -153,6 +163,12 @@ if [[ -n "$DaysOld" ]]; then
exit 2 exit 2
fi fi
fi fi
if [[ -n "$DaysKept" ]]; then
if ! [[ $DaysKept =~ ^[0-9]+$ ]]; then
printf "-k argument given (%s) is not a number.\n" "$DaysKept"
exit 2
fi
fi
if [[ -n "$CollectorTextFileDirectory" ]]; then if [[ -n "$CollectorTextFileDirectory" ]]; then
if ! [[ -d $CollectorTextFileDirectory ]]; then if ! [[ -d $CollectorTextFileDirectory ]]; then
printf "The directory (%s) does not exist.\n" "$CollectorTextFileDirectory" printf "The directory (%s) does not exist.\n" "$CollectorTextFileDirectory"
@@ -193,11 +209,11 @@ self_update() {
printf "\n%s\n" "Pulling the latest version." printf "\n%s\n" "Pulling the latest version."
git pull --force || { printf "%bGit error,%b manually pull/clone.\n" "$c_red" "$c_reset"; return; } git pull --force || { printf "%bGit error,%b manually pull/clone.\n" "$c_red" "$c_reset"; return; }
printf "\n%s\n" "--- starting over with the updated version ---" printf "\n%s\n" "--- starting over with the updated version ---"
cd - || { printf "%bPath error.%b\n" "$c_red"; return; } cd - || { printf "%bPath error.%b\n" "$c_red" "$c_reset"; return; }
exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments exec "$ScriptPath" "${ScriptArgs[@]}" # run the new script with old arguments
exit 0 # exit the old instance exit 0 # exit the old instance
else else
cd - || { printf "%bPath error.%b\n" "$c_red"; return; } cd - || { printf "%bPath error.%b\n" "$c_red" "$c_reset"; return; }
self_update_curl self_update_curl
fi fi
} }
@@ -213,6 +229,7 @@ choosecontainers() {
else else
ChoiceClean=${Choice//[,.:;]/ } ChoiceClean=${Choice//[,.:;]/ }
for CC in $ChoiceClean; do for CC in $ChoiceClean; do
CC=$((10#$CC)) # Base 10 interpretation to strip leading zeroes
if [[ "$CC" -lt 1 || "$CC" -gt $UpdCount ]]; then # Reset choice if out of bounds if [[ "$CC" -lt 1 || "$CC" -gt $UpdCount ]]; then # Reset choice if out of bounds
echo "Number not in list: $CC"; unset ChoiceClean; break 1 echo "Number not in list: $CC"; unset ChoiceClean; break 1
else else
@@ -224,10 +241,11 @@ choosecontainers() {
} }
datecheck() { datecheck() {
ImageDate=$("$regbin" -v error image inspect "$RepoUrl" --format='{{.Created}}' | cut -d" " -f1) ImageDate="$1"
DaysMax="$2"
ImageEpoch=$(date -d "$ImageDate" +%s 2>/dev/null) || ImageEpoch=$(date -f "%Y-%m-%d" -j "$ImageDate" +%s) ImageEpoch=$(date -d "$ImageDate" +%s 2>/dev/null) || ImageEpoch=$(date -f "%Y-%m-%d" -j "$ImageDate" +%s)
ImageAge=$(( ( $(date +%s) - ImageEpoch )/86400 )) ImageAge=$(( ( RunEpoch - ImageEpoch )/86400 ))
if [[ "$ImageAge" -gt "$DaysOld" ]]; then if [[ "$ImageAge" -gt "$DaysMax" ]]; then
return 0 return 0
else else
return 1 return 1
@@ -342,18 +360,19 @@ dependency_check() {
dependency_check "regctl" "regbin" "https://github.com/regclient/regclient/releases/latest/download/regctl-linux-TEMP" dependency_check "regctl" "regbin" "https://github.com/regclient/regclient/releases/latest/download/regctl-linux-TEMP"
dependency_check "jq" "jqbin" "https://github.com/jqlang/jq/releases/latest/download/jq-linux-TEMP" dependency_check "jq" "jqbin" "https://github.com/jqlang/jq/releases/latest/download/jq-linux-TEMP"
# Numbered List function # Numbered List function - pads with zero
# if urls.list exists add release note url per line
list_options() { list_options() {
num=1 local total="${#Updates[@]}"
[[ ${#total} < 2 ]] && local pads=2 || local pads="${#total}"
local num=1
for update in "${Updates[@]}"; do for update in "${Updates[@]}"; do
echo "$num) $update" printf "%0*d - %s\n" "$pads" "$num" "$update"
((num++)) ((num++))
done done
} }
# Version check & initiate self update # Version check & initiate self update
if [[ "$LatestRelease" != "undefined" ]]; then if [[ "$LatestSnippet" != "undefined" ]]; then
if [[ "$VERSION" != "$LatestRelease" ]]; then if [[ "$VERSION" != "$LatestRelease" ]]; then
printf "New version available! %b%s%b ⇒ %b%s%b \n Change Notes: %s \n" "$c_yellow" "$VERSION" "$c_reset" "$c_green" "$LatestRelease" "$c_reset" "$LatestChanges" printf "New version available! %b%s%b ⇒ %b%s%b \n Change Notes: %s \n" "$c_yellow" "$VERSION" "$c_reset" "$c_green" "$LatestRelease" "$c_reset" "$LatestChanges"
if [[ "$AutoMode" == false ]]; then if [[ "$AutoMode" == false ]]; then
@@ -423,6 +442,10 @@ check_image() {
printf "%s\n" "NoUpdates !$i - not checked, no compose file" printf "%s\n" "NoUpdates !$i - not checked, no compose file"
return return
fi fi
# Checking if Label Only -option is set, and if container got the label
ContUpdateLabel=$($jqbin -r '."mag37.dockcheck.update"' <<< "$ContLabels")
[[ "$ContUpdateLabel" == "null" ]] && ContUpdateLabel=""
[[ "$OnlyLabel" == true ]] && { [[ "$ContUpdateLabel" != true ]] && { echo "Skip $i"; return; } }
local NoUpdates GotUpdates GotErrors local NoUpdates GotUpdates GotErrors
ImageId=$(docker inspect "$i" --format='{{.Image}}') ImageId=$(docker inspect "$i" --format='{{.Image}}')
@@ -434,7 +457,7 @@ check_image() {
if [[ "$LocalHash" == *"$RegHash"* ]]; then if [[ "$LocalHash" == *"$RegHash"* ]]; then
printf "%s\n" "NoUpdates $i" printf "%s\n" "NoUpdates $i"
else else
if [[ -n "${DaysOld:-}" ]] && ! datecheck; then if [[ -n "${DaysOld:-}" ]] && ! datecheck $("$regbin" -v error image inspect "$RepoUrl" --format='{{.Created}}' | cut -d" " -f1) "$DaysOld" ; then
printf "%s\n" "NoUpdates +$i ${ImageAge}d" printf "%s\n" "NoUpdates +$i ${ImageAge}d"
else else
printf "%s\n" "GotUpdates $i" printf "%s\n" "GotUpdates $i"
@@ -448,7 +471,7 @@ check_image() {
# Make required functions and variables available to subprocesses # Make required functions and variables available to subprocesses
export -f check_image datecheck export -f check_image datecheck
export Excludes_string="${Excludes[*]:-}" # Can only export scalar variables export Excludes_string="${Excludes[*]:-}" # Can only export scalar variables
export t_out regbin RepoUrl DaysOld DRunUp jqbin export t_out regbin RepoUrl DaysOld DRunUp jqbin OnlyLabel RunTimestamp RunEpoch
# Check for POSIX xargs with -P option, fallback without async # Check for POSIX xargs with -P option, fallback without async
if (echo "test" | xargs -P 2 >/dev/null 2>&1) && [[ "$MaxAsync" != 0 ]]; then if (echo "test" | xargs -P 2 >/dev/null 2>&1) && [[ "$MaxAsync" != 0 ]]; then
@@ -478,6 +501,8 @@ done < <( \
xargs $XargsAsync -I {} bash -c 'check_image "{}"' \ xargs $XargsAsync -I {} bash -c 'check_image "{}"' \
) )
[[ "$OnlyLabel" == true ]] && printf "\n%bLabel option active:%b Only checking containers with labels set.\n" "$c_blue" "$c_reset"
# Sort arrays alphabetically # Sort arrays alphabetically
IFS=$'\n' IFS=$'\n'
NoUpdates=($(sort <<<"${NoUpdates[*]:-}")) NoUpdates=($(sort <<<"${NoUpdates[*]:-}"))
@@ -529,14 +554,22 @@ if [[ -n "${GotUpdates:-}" ]]; then
for i in "${SelectedUpdates[@]}"; do for i in "${SelectedUpdates[@]}"; do
((CurrentQue+=1)) ((CurrentQue+=1))
printf "\n%bNow updating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset" printf "\n%bNow updating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset"
ContLabels=$(docker inspect "$i" --format '{{json .Config.Labels}}') ContConfig=$(docker inspect "$i" --format '{{json .}}')
ContImage=$(docker inspect "$i" --format='{{.Config.Image}}') ContImage=$($jqbin -r '."Config"."Image"' <<< "$ContConfig")
ContPath=$($jqbin -r '."com.docker.compose.project.working_dir"' <<< "$ContLabels") ImageId=$($jqbin -r '."Image"' <<< "$ContConfig")
ContPath=$($jqbin -r '."Config"."Labels"."com.docker.compose.project.working_dir"' <<< "$ContConfig")
[[ "$ContPath" == "null" ]] && ContPath="" [[ "$ContPath" == "null" ]] && ContPath=""
ContUpdateLabel=$($jqbin -r '."mag37.dockcheck.update"' <<< "$ContLabels")
[[ "$ContUpdateLabel" == "null" ]] && ContUpdateLabel="" # Add new backup tag prior to pulling if option is set
# Checking if Label Only -option is set, and if container got the label if [[ -n "${DaysKept:-}" ]]; then
[[ "$OnlyLabel" == true ]] && { [[ "$ContUpdateLabel" != true ]] && { echo "No update label, skipping."; continue; } } ContRepoDigests=$(docker image inspect "$ImageId" --format "{{index .RepoDigests 0}}")
ContRepo=${ContImage%:*}
ContApp=${ContRepo#*/}
[[ "$ContImage" =~ ":" ]] && ContTag=${ContImage#*:} || ContTag="latest"
BackupName="dockcheck/${ContApp}:${RunTimestamp}_${ContTag}"
docker tag "$ImageId" "$BackupName"
printf "%b%s backed up as %s%b\n" "$c_teal" "$i" "$BackupName" "$c_reset"
fi
# Checking if compose-values are empty - hence started with docker run # Checking if compose-values are empty - hence started with docker run
if [[ -z "$ContPath" ]]; then if [[ -z "$ContPath" ]]; then
@@ -549,17 +582,27 @@ if [[ -n "${GotUpdates:-}" ]]; then
continue continue
fi fi
docker pull "$ContImage" || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; } if docker pull "$ContImage"; then
done # Removal of the <none>-tag image left behind from backup
printf "\n%bDone pulling updates. %bRecreating updated containers.%b\n" "$c_green" "$c_blue" "$c_reset" [[ -n "${DaysKept:-}" ]] && docker rmi "$ContRepoDigests"
else
printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1
fi
done
printf "\n%bDone pulling updates.%b\n" "$c_green" "$c_reset"
if [[ "$SkipRecreate" == true ]]; then
printf "%bSkipping container recreation due to -R.%b\n" "$c_yellow" "$c_reset"
else
printf "%bRecreating updated containers.%b\n" "$c_blue" "$c_reset"
CurrentQue=0 CurrentQue=0
for i in "${SelectedUpdates[@]}"; do for i in "${SelectedUpdates[@]}"; do
((CurrentQue+=1)) ((CurrentQue+=1))
unset CompleteConfs unset CompleteConfs
# Extract labels and metadata # Extract labels and metadata
ContLabels=$(docker inspect "$i" --format '{{json .Config.Labels}}') ContConfig=$(docker inspect "$i" --format '{{json .}}')
ContImage=$(docker inspect "$i" --format='{{.Config.Image}}') ContLabels=$($jqbin -r '."Config"."Labels"' <<< "$ContConfig")
ContPath=$($jqbin -r '."com.docker.compose.project.working_dir"' <<< "$ContLabels") ContPath=$($jqbin -r '."com.docker.compose.project.working_dir"' <<< "$ContLabels")
[[ "$ContPath" == "null" ]] && ContPath="" [[ "$ContPath" == "null" ]] && ContPath=""
ContConfigFile=$($jqbin -r '."com.docker.compose.project.config_files"' <<< "$ContLabels") ContConfigFile=$($jqbin -r '."com.docker.compose.project.config_files"' <<< "$ContLabels")
@@ -568,8 +611,6 @@ if [[ -n "${GotUpdates:-}" ]]; then
[[ "$ContName" == "null" ]] && ContName="" [[ "$ContName" == "null" ]] && ContName=""
ContEnv=$($jqbin -r '."com.docker.compose.project.environment_file"' <<< "$ContLabels") ContEnv=$($jqbin -r '."com.docker.compose.project.environment_file"' <<< "$ContLabels")
[[ "$ContEnv" == "null" ]] && ContEnv="" [[ "$ContEnv" == "null" ]] && ContEnv=""
ContUpdateLabel=$($jqbin -r '."mag37.dockcheck.update"' <<< "$ContLabels")
[[ "$ContUpdateLabel" == "null" ]] && ContUpdateLabel=""
ContRestartStack=$($jqbin -r '."mag37.dockcheck.restart-stack"' <<< "$ContLabels") ContRestartStack=$($jqbin -r '."mag37.dockcheck.restart-stack"' <<< "$ContLabels")
[[ "$ContRestartStack" == "null" ]] && ContRestartStack="" [[ "$ContRestartStack" == "null" ]] && ContRestartStack=""
ContOnlySpecific=$($jqbin -r '."mag37.dockcheck.only-specific-container"' <<< "$ContLabels") ContOnlySpecific=$($jqbin -r '."mag37.dockcheck.only-specific-container"' <<< "$ContLabels")
@@ -578,8 +619,6 @@ if [[ -n "${GotUpdates:-}" ]]; then
printf "\n%bNow recreating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset" printf "\n%bNow recreating (%s/%s): %b%s%b\n" "$c_teal" "$CurrentQue" "$NumberofUpdates" "$c_blue" "$i" "$c_reset"
# Checking if compose-values are empty - hence started with docker run # Checking if compose-values are empty - hence started with docker run
[[ -z "$ContPath" ]] && { echo "Not a compose container, skipping."; continue; } [[ -z "$ContPath" ]] && { echo "Not a compose container, skipping."; continue; }
# Checking if Label Only -option is set, and if container got the label
[[ "$OnlyLabel" == true ]] && { [[ "$ContUpdateLabel" != true ]] && { echo "No update label, skipping."; continue; } }
# cd to the compose-file directory to account for people who use relative volumes # cd to the compose-file directory to account for people who use relative volumes
cd "$ContPath" || { printf "\n%bPath error - skipping%b %s" "$c_red" "$c_reset" "$i"; continue; } cd "$ContPath" || { printf "\n%bPath error - skipping%b %s" "$c_red" "$c_reset" "$i"; continue; }
@@ -602,14 +641,40 @@ if [[ -n "${GotUpdates:-}" ]]; then
${DockerBin} ${CompleteConfs} ${ContEnvs} up -d ${SpecificContainer} || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; } ${DockerBin} ${CompleteConfs} ${ContEnvs} up -d ${SpecificContainer} || { printf "\n%bDocker error, exiting!%b\n" "$c_red" "$c_reset" ; exit 1; }
fi fi
done done
if [[ "$AutoPrune" == false ]] && [[ "$AutoMode" == false ]]; then printf "\n"; read -rep "Would you like to prune dangling images? y/[n]: " AutoPrune; fi fi
if [[ "$AutoPrune" == true ]] || [[ "$AutoPrune" =~ [yY] ]]; then printf "\nAuto pruning.."; docker image prune -f; fi printf "\n%bAll updates done!%b\n" "$c_green" "$c_reset"
printf "\n%bAll done!%b\n" "$c_green" "$c_reset"
# Clean up old backup image tags if -k is used
if [[ -n "${DaysKept:-}" ]]; then
IFS=$'\n'
CleanupCount=0
for backup_img in $(docker images --format "{{.Repository}} {{.Tag}}" | sed -n '/^dockcheck/p'); do
repo_name=${backup_img% *}
backup_tag=${backup_img#* }
backup_date=${backup_tag%%_*}
# UNTAGGING HERE
if datecheck "$backup_date" "$DaysKept"; then
[[ "$CleanupCount" == 0 ]] && echo "Removing backed up images older then $DaysKept days."
docker rmi "${repo_name}:${backup_tag}" && ((CleanupCount+=1))
fi
done
unset IFS
if [[ "$CleanupCount" == 0 ]]; then
printf "\nNo backup images to remove.\n"
else else
printf "\nNo updates installed, exiting.\n" printf "\n%b%s%b backup images removed.%b\n" "$c_green" "$CleanupCount" "$c_teal" "$c_reset"
docker image prune -f
fi
else
if [[ "$AutoPrune" == false ]] && [[ "$AutoMode" == false ]]; then printf "\n"; read -rep "Would you like to prune all dangling images? y/[n]: " AutoPrune; fi
if [[ "$AutoPrune" == true ]] || [[ "$AutoPrune" =~ [yY] ]]; then printf "\nAuto pruning.."; docker image prune -f; fi
fi
else
printf "\nNo updates installed.\n"
fi fi
else else
printf "\nNo updates available, exiting.\n" printf "\nNo updates available.\n"
fi fi
exit 0 exit 0

View File

@@ -38,35 +38,15 @@ You can also use the [caronc/apprise-api](https://github.com/caronc/apprise-api)
### Customize the **notify.sh** file. ### Customize the **notify.sh** file.
After you're done with the setup of the container and tried your notifications, you can copy the `notify_apprise.sh` file to `notify.sh` and start editing it. After you're done with the setup of the container and tried your notifications, you need to follow the configuration setup (explained in detail in the README).
Briefly: Copy `default.config` to `dockcheck.config` then edit it to change the following, `APPRISE_URL` matching your environment:
Comment out/remove the bare metal apprise-command (starting with `apprise -vv -t...`).
Uncomment and edit the `AppriseURL` variable and *curl* line
It should look something like this when curling the API:
```bash ```bash
send_notification() { NOTIFY_CHANNELS="apprise"
Updates=("$@") APPRISE_URL="http://apprise.mydomain.tld:1234/notify/apprise"
UpdToString=$( printf "%s\n" "${Updates[@]}" )
FromHost=$(hostname)
printf "\nSending Apprise notification\n"
MessageTitle="$FromHost - updates available."
# Setting the MessageBody variable here.
read -d '\n' MessageBody << __EOF
Containers on $FromHost with updates available:
$UpdToString
__EOF
AppriseURL="http://IP.or.mydomain.tld:8000/notify/apprise"
curl -X POST -F "title=$MessageTitle" -F "body=$MessageBody" -F "tags=all" $AppriseURL
}
``` ```
That's all! That's it!
___ ___
___ ___